/* Expandable vector, grows in-place as new elements are added to the back. 
 * Tim Bailey 2003. */
#ifndef EXPANDABLE_VECTOR_H_
#define EXPANDABLE_VECTOR_H_

typedef double ValueType;

typedef struct Vector {
    ValueType *data; /* pointer to vector elements */
    int size;        /* current size of vector */
    int capacity;    /* current reserved memory for vector */
} Vector;

/* Vector creation. */
Vector create_vector(int capacity);
void release_vector(Vector *v);

/* Vector access operations. */
int push_back(Vector *v, ValueType item);
ValueType pop_back(Vector *v);
ValueType* get_element(Vector *v, int index);

/* Manual resizing operations. */
int get_size(Vector *v);
int set_size(Vector *v, int size);
int get_capacity(Vector *v);
int set_capacity(Vector *v, int size);

#endif
